#if !defined HAVE_COMBMINCHANGE_H__
#define      HAVE_COMBMINCHANGE_H__


#include "funcemu.h"
#include "bitcombination.h"  // first_comb()
#include "fxttypes.h"

#include "fxtio.h"


class comb_minchange
{
public:
    ulong n_;
    ulong k_;
    ulong bits_;
    ulong last_;
    ulong sw1_, sw2_;
    ulong *x_;
    funcemu<ulong> *fe_;

public:
    comb_minchange(ulong n, ulong k);
    ~comb_minchange();

    ulong first()
    {
        bits_ = first_comb(k_);
        sync_x();
        sw1_ = sw2_ = 0;
        return  bits_;
    }

    ulong next()  // return zero if previous comb was the last
    {
        if ( bits_ == last_ )  return 0;

        next_recursion();
        sync_x();
        return  bits_;
    }

    const ulong * data()  { return x_; }

    friend ostream & operator << (ostream &os, const comb_minchange &x);

//private:
    void sync_x();
    void bit_swap_01(ulong n, ulong k);
    ulong next_recursion();
};
// -------------------------



#endif  // !defined HAVE_COMBMINCHANGE_H__
