#if !defined HAVE_SUBSETLEX_H__
#define      HAVE_SUBSETLEX_H__


#include "fxttypes.h"
#include "newop.h"
#include "bitcombination.h"


class subset_lex
{
protected:
    ulong *x;
    ulong n;
    ulong k;
    ulong num;


public:
    subset_lex(ulong nn)
    {
        n = (nn ? nn : 1);  // not zero
        x = NEWOP(ulong, n+1);
        first();
    }

    ~subset_lex()  { delete [] x; }


    ulong first()
    {
        k = 0;
        num = 1;
        x[0] = 0;
        return  num;
    }

    ulong next()  // return number of elements in subset
    {  // based on code by Glenn C. Rhoads
        if ( x[k] == n-1 )
        {
            if ( 0==k )  { return 0; }  // jjnote: user has to call first() again
            --k;
            x[k]++;
        }
        else
        {
            ++k;
            x[k] = x[k-1] + 1;
        }

        num = k + 1;
        return  num;
    }

    const ulong * data()  { return x; }
};
// -------------------------



#endif  // !defined HAVE_SUBSETLEX_H__
